/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	Tv^[QbgˑW[iCQ7144Apj
 */


#include	"sample_config.h"
#include	"sh7144.h"


/*
 *  OIL`V{̊OQ
 */
DeclareCounter( SampleCnt );


/*
 *	֐vg^Cv錾
 */
ISR( CounterInt );
ISR( HwCnt2Int );


/*
 *  AvP[V[hp
 */
/*
 *  AvP[V[hp̏擾
 *
 *  VXeƂɔCӂ͎̓@ɂ邱ƁD
 *  0,1,2ʂł邱ƁD32ƓɂȂD
 */
UINT8
GetAppModeInfo( void )
{
	/*
	 *  {͂ŃAvP[V[h̔sׂA
	 *  {[hɃ[h擾łH/WĂȂ߁A
	 *  0ԂD
	 */
	
	return 0;

}	/* GetAppModeInfo	*/


/*
 *  TvJE^\[Xp
 *
 *  CQ7144AłCMT1ŎD
 */

/*
 *  SignalCounterspݏ
 *
 *  ^C}̋N͕ʊ֐ōsD
 */
void
InitCounterInt( void )
{
	/*
	 *  CMTW[X^oC
	 */
	MSTCR2 &= (UINT16)~0x1000;		/* CMTL */
	
	/*
	 *  RyA}b`^C}~ĊeWX^ݒ
	 */
	CMSTR &= (UINT16) ~0x0002;		/* JEg~ */

	/*
	 *   ӃNbN 1/8, 荞݋֎~
	 *  CMCSR  bit7 ݗvtOłCɃNAĂD
	 */
	CMCSR_1 = 0x0000;

	/*
	 *  Ry}b`JE^ڕWlݒ
	 *  ^C}NɃRyA}b`邽
	 */
	CMCOR_1 = (UINT16)0x0001;

	/*
	 *  ^C}RyA݃xݒiݒ背x̓wb_QƁj
	 */
	IPRG = (UINT16) ((IPRG & ~0xF) | (UINT16)CFG_INTLVL_COUNTER);

	/*
	 *  JE^NAƊ݋
	 */
	CMCNT_1 = 0x0000;				/* JEgNA */
	CMCSR_1 |= 0x0040;				/* RyA}b`݋ */

}	/* InitCounterInt	*/

/*
 *  SignalCounterspݒ~
 */
void
TermCounterInt( void )
{
	CMSTR &= (UINT16) ~0x0002;		/* JEg~ */
	CMCSR_1 = 0x0000;				/* @\ */
}	/* TermCounterInt	*/

/*
 *  SignalCountersp݋N
 */
void
ActCounterInt( void )
{
	CMCNT_1 = (UINT16)0x0000;		/* JEgNA */
	CMSTR |= (UINT16) 0x0002;		/* JEgJn */
}	/* ActCounterInt	*/

/*
 *  SignalCountersp݃T[rX[`
 */
ISR( CounterInt )
{
	StatusType ercd;

	/*
	 *  1̂ SignalCounter s߁C^C}~D
	 */
	CMCSR_1 &= (UINT16)~0x0040;		/* RyA}b`݋֎~ */
	CMSTR &= (UINT16) ~0x0002;		/* JEg~ */

	/*
	 *  ݗvNA
	 */
	CMCSR_1 &= (UINT16)~0x0080;		/* ݗvNA */

	/*
	 *  JE^Zʒms
	 */
	ercd = SignalCounter( SampleCnt );

	/* G[^[̏ꍇ̓Vbg_E	*/
	if( ercd != E_OK ){
		ShutdownOS( ercd );
	}
}	/* ISR( CounterInt )	*/


/*
 *  ISR1EISR2ғmFp
 *
 *  CQ7144AłMTUA1,B2ŎD
 */
/*
 *  n[hEFAJE^obt@
 */
static UINT8	hw_cnt1;
static UINT8	hw_cnt2;

/*
 *  ISR1EISR2JE^
 */
void
InitHwCntInt( void )
{
	/*
	 *  n[hEFAJE^
	 */
	hw_cnt1 = (UINT8)0;
	hw_cnt2 = (UINT8)0;

	/*
	 *  MTUW[X^oC
	 */
	MSTCR2 &= (UINT16)~0x2000;		/* MTUL */

	/*
	 *  ^C}~ĊeWX^ݒ
	 */
	TSTR &= (UINT8)~0x06;

	/*
	 *  ^C}JE^NA
	 */
	TCNT_1 = (UINT16)0x0000;
	TCNT_2 = (UINT16)0x0000;
	
	/*
	 *  ^C}`l1,2 AbvGbW, 1/64
	 *  ^C}`l1 = TGR-A
	 *  ^C}`l2 = TGR-B
	 */
	TCR_1 = (UINT8)0x23;
	TCR_2 = (UINT8)0x43;

	/*
	 *  RyA}b`JE^ݒ
	 */
	TGRA_1 = CFG_HW_CNT1;
	TGRB_2 = CFG_HW_CNT2;

	/*
	 *  ^C}RyA݃xݒiݒ背x̓wb_QƁj
	 *  TSR  bit0,1 ݗvtOɂNAĂD
	 */
	IPRD = (UINT16) ((IPRD & ~(0xFu <<  4)) | (CFG_INTLVL_HW_CNT1 <<  4));
	IPRE = (UINT16) ((IPRE & ~(0xFu << 12)) | (CFG_INTLVL_HW_CNT2 << 12));
	TSR_1 &= (UINT8) ~0x01;
	TSR_2 &= (UINT8) ~0x02;

	/*
	 * ݋ A,B
	 */
	TIER_1 |= (UINT8)0x01;
	TIER_2 |= (UINT8)0x02;

	/*
	 *  ^C}JEgJn
	 */
	TSTR |= (UINT8)0x06;

}	/* InitHwCntInt	*/

/*
 *  ISR1EISR2JE^~
 */
void
TermHwCntInt( void )
{
	TIER_1 &= (UINT8) ~0x01;	/* ݋֎~		*/
	TIER_2 &= (UINT8) ~0x02;	/* ݋֎~		*/
	TSTR   &= (UINT8) ~0x06;	/* JEg~		*/
}	/* TermHwCntInt	*/

/*
 *  ISR1EISR2JE^擾
 *
 *  hw_cnt1hw_cnt2̓擾͕ۏႵȂĂ悢i݋֎~͕svjD
 */
void
GetHwCnt( UINT8 *isr1_cnt, UINT8 *isr2_cnt )
{
	*isr1_cnt = hw_cnt1;
	*isr2_cnt = hw_cnt2;
}	/* GetHwCnt	*/

/*
 *  ISR1JE^Zp݃T[rX[`
 */
#if defined( OMIT_ISR1_ENTRY )
/* ISR1͖{֐݊֐w肷	*/
#pragma interrupt	HwCnt1Int
#endif	/* OMIT_ISR1_ENTRY	*/
void	HwCnt1Int( void );
void
HwCnt1Int( void )
{
	/* ݗvNA */
	TSR_1 &= (UINT8)~0x01;

	hw_cnt1++;
}	/* HwCnt1Int	*/

/*
 *  ISR2JE^Zp݃T[rX[`
 */
ISR( HwCnt2Int )
{
	/* ݗvNA */
	TSR_2 &= (UINT8)~0x02;

	hw_cnt2++;
}	/* ISR( HwCnt2Int )	*/


